/**
* teamgen.h - Utility for instructing the TCA module to
* add/delete a team from its database. The two processes communicate
* via a message queue
*
* Copyright (C) 2004-2005 Pantelis Frangoudis, Elias Efstathiou
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef _TEAM_GEN_H
#define _TEAM_GEN_H

//mqueue specific decls
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "types.h"
#include "io.h"

#include <signal.h>
#include <errno.h>

key_t mq_key = 321;
int mq_id;

#define MTYPE_ADD_TEAM 10 //message type: handle team insertion/deletion
#define MTYPE_DEL_TEAM 20

#define MAX_MSG_LEN 4096

//message buffer - this msg will be sent to the tca  module in case a new team has to be added (or an old team removed)
typedef struct msgbuf_t {
	long mtype;
	char mdata[1];
} MSG_BUF;

//initializes message queue
int init_mq();

//sends command to message queue to be processed by the other process
int send_cmd(PWNC_PUBKEY *team_pub, int action);

#endif /* _TEAM_GEN_H */
